import { ref as i, computed as x, useSlots as Pa, onMounted as aa, watch as F, nextTick as he, onBeforeUnmount as Ra, createElementBlock as ee, openBlock as w, unref as z, normalizeClass as Fa, normalizeStyle as V, createCommentVNode as _, createBlock as E, createElementVNode as ae, createSlots as Ea, withCtx as m, renderSlot as L, normalizeProps as Z, guardReactiveProps as G, createVNode as Da, toDisplayString as la, createTextVNode as Aa } from "vue";
import { u as Na, c as Ha, t as _a, p as U, a as Ua, C as ye, b as Wa, D as we, i as le, f as te, d as ta, _ as Xa, J as Ya, a9 as Ba, o as Va, e as Za, x as oa, q as Ga, r as ja, y as qa, s as oe, l as Ja } from "./index-CokOzopo.js";
import { d as Ka, t as Qa, u as el, c as al, a as ra, l as b, r as ze, b as D, p as ua } from "./useResponsive-CoxXLe23.js";
import { _ as ll } from "./Tooltip-D5tlGuh0.js";
import { L as tl } from "./Legend-DX8CljeB.js";
import { _ as ol } from "./Title-_eGGQuGI.js";
import { S as rl } from "./Slicer-CSsMiE8f.js";
import { u as ul, U as sl } from "./usePrinter-BzR_jvGv.js";
import nl from "./vue-ui-accordion-De733ske.js";
import { D as il } from "./DataTable-Cm5zBJcA.js";
import vl from "./vue-ui-skeleton-C3Lk5ZAd.js";
import { u as sa } from "./useNestedProp--JNGbFip.js";
import { P as cl } from "./PenAndPaper-BcMwzhXy.js";
import { u as dl } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as hl } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const yl = ["id"], fl = ["onClick"], gl = {
  key: 2,
  class: "vue-data-ui-watermark"
}, pl = ["innerHTML"], ml = {
  __name: "vue-ui-xy-canvas",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend"],
  setup(Se, { expose: na, emit: ia }) {
    const { vue_ui_xy_canvas: va } = Na(), g = Se, fe = i(Ha()), j = i(null), T = i(null), q = i(null), s = i(null), f = i(1), P = i(1), re = i(!1), d = i(null), ue = i(""), $e = i(null), $ = i([]), W = i(1), A = i(!0), X = i(!0), ge = i(null), Ie = i(0), Te = i(0), se = i(!1), Me = i(null), Oe = i(null), Pe = i(null), Re = i(null), pe = i(0), me = i(0), be = i(0), M = i(null), xe = x(() => !!g.dataset && g.dataset.length), ca = ia, da = Pa();
    aa(() => {
      da["chart-background"] && console.warn("VueUiXyCanvas does not support the #chart-background slot.");
    });
    const a = x({
      get: () => De(),
      set: (e) => e
    }), { userOptionsVisible: Le, setUserOptionsVisibility: Fe, keepUserOptionState: Ee } = dl({ config: a.value });
    function De() {
      const e = sa({
        userConfig: g.config,
        defaultConfig: va
      });
      let t = {};
      return e.theme ? t = {
        ...sa({
          userConfig: Ua.vue_ui_xy_canvas[e.theme] || g.config,
          defaultConfig: e
        }),
        customPalette: _a[e.theme] || U
      } : t = e, g.config && ye(g.config, "style.chart.scale.min") ? t.style.chart.scale.min = g.config.style.chart.scale.min : t.style.chart.scale.min = null, g.config && ye(g.config, "style.chart.scale.max") ? t.style.chart.scale.max = g.config.style.chart.scale.max : t.style.chart.scale.max = null, g.config && ye(g.config, "style.chart.zoom.startIndex") ? t.style.chart.zoom.startIndex = g.config.style.chart.zoom.startIndex : t.style.chart.zoom.startIndex = null, g.config && ye(g.config, "style.chart.zoom.endIndex") ? t.style.chart.zoom.endIndex = g.config.style.chart.zoom.endIndex : t.style.chart.zoom.endIndex = null, t;
    }
    F(() => g.config, (e) => {
      a.value = De(), Le.value = !a.value.userOptions.showOnChartHover, ke(), pe.value += 1, me.value += 1, be.value += 1, u.value.showTable = a.value.table.show, u.value.showDataLabels = a.value.style.chart.dataLabels.show, u.value.stacked = a.value.style.chart.stacked, u.value.showTooltip = a.value.style.chart.tooltip.show;
    }, { deep: !0 }), F(() => g.dataset, () => {
      ke(), pe.value += 1, me.value += 1, be.value += 1;
    }, { deep: !0 });
    const Ae = i(a.value.style.chart.aspectRatio), { isPrinting: Ne, isImaging: He, generatePdf: _e, generateImage: Ue } = ul({
      elementId: `xy_canvas_${fe.value}`,
      fileName: a.value.style.chart.title.text || "vue-ui-xy-canvas"
    }), u = i({
      showTable: a.value.table.show,
      showDataLabels: a.value.style.chart.dataLabels.show,
      stacked: a.value.style.chart.stacked,
      showTooltip: a.value.style.chart.tooltip.show
    });
    function ha(e) {
      se.value = e, Te.value += 1;
    }
    const We = x(() => Wa(a.value.customPalette)), I = x(() => Y.value ? Math.max(...Y.value.filter((e, t) => !$.value.includes(e.absoluteIndex)).map((e) => e.series.length)) : 0), l = x(() => {
      const e = f.value - f.value * (a.value.style.chart.paddingProportions.left + a.value.style.chart.paddingProportions.right);
      return {
        canvasWidth: f.value,
        canvasHeight: P.value,
        left: f.value * a.value.style.chart.paddingProportions.left,
        top: P.value * a.value.style.chart.paddingProportions.top,
        right: f.value - f.value * a.value.style.chart.paddingProportions.right,
        bottom: P.value - P.value * a.value.style.chart.paddingProportions.bottom,
        width: e,
        height: P.value - P.value * (a.value.style.chart.paddingProportions.top + a.value.style.chart.paddingProportions.bottom),
        slot: e / (r.value.end - r.value.start)
      };
    });
    function Xe(e, t) {
      return e / t;
    }
    function ya({ hasAutoScale: e, series: t, min: o, max: n, scale: c, yOffset: C, individualHeight: v, stackIndex: y = null }) {
      return t.map((N, S) => {
        const R = c.min < 0 ? Math.abs(c.min) : 0, H = Xe(N + R, R + c.max);
        let K, Q;
        e && (K = c.min, Q = Xe(N - K, c.max - K));
        let O = 0;
        return y === null ? O = l.value.bottom - l.value.height * (e ? Q : H) : O = l.value.bottom - C - v * (e ? Q : H), {
          x: l.value.left + l.value.slot * S + l.value.slot / 2,
          y: O,
          value: N
        };
      });
    }
    const p = x(() => {
      const e = a.value.style.chart.scale.min !== null ? a.value.style.chart.scale.min : Math.min(...Y.value.filter((v, y) => !$.value.includes(v.absoluteIndex)).flatMap((v) => v.series.slice(r.value.start, r.value.end))), t = a.value.style.chart.scale.max !== null ? a.value.style.chart.scale.max : Math.max(...Y.value.filter((v, y) => !$.value.includes(v.absoluteIndex)).flatMap((v) => v.series.slice(r.value.start, r.value.end))), o = we(e < 0 ? e : 0, t === e ? e + 1 < 0 ? 0 : e + 1 : t < 0 ? 0 : t, a.value.style.chart.scale.ticks), n = o.min < 0 ? Math.abs(o.min) : 0, c = l.value.bottom - l.value.height * (n / (o.max + n)), C = o.ticks.map((v) => ({
        y: l.value.bottom - l.value.height * ((v + n) / (o.max + n)),
        x: l.value.left - 8,
        value: v
      }));
      return {
        absoluteMin: n,
        max: t,
        min: e,
        scale: o,
        yLabels: C,
        zero: c
      };
    }), fa = x(() => h.value.map((e) => `
            <div style="display:flex;flex-direction:row;gap:6px;align-items:center;">
                <svg viewBox="0 0 10 10" height="12" width="12">
                    <circle cx="5" cy="5" r="5" fill="${e.color}"/>
                </svg>
                <span>${e.name ? e.name + ": " : ""}</span>
                <span>${le(
      a.value.style.chart.dataLabels.formatter,
      e.series[d.value],
      te({
        p: e.prefix || "",
        v: e.series[d.value],
        s: e.suffix || "",
        r: e.rounding || 0
      }),
      { datapoint: e, seriesIndex: d.value }
    )}</span>
            </div>
        `)), Y = x(() => g.dataset.map((e, t) => ({
      ...e,
      series: Xa({
        data: Ya(e.series),
        threshold: a.value.downsample.threshold
      }),
      absoluteIndex: t,
      color: ta(e.color || We.value[t] || U[t] || U[t % U.length])
    })));
    F(I, (e) => {
      e && Ye();
    });
    const h = x(() => Ba(Y.value.filter((e, t) => !$.value.includes(e.absoluteIndex))).map((e, t) => ({
      ...e,
      series: e.series.slice(r.value.start, r.value.end)
    })).map((e, t) => {
      let o = [null, void 0].includes(e.scaleMin) ? Math.min(...e.series) || 0 : e.scaleMin, n = [null, void 0].includes(e.scaleMax) ? Math.max(...e.series) || 1 : e.scaleMax;
      o === n && (o = o >= 0 ? n - 1 : o, n = n >= 0 ? n : o + 1), e.series.filter((O) => ![null, void 0].includes(O)).map((O) => (O - o) / (n - o));
      const c = {
        valueMin: o,
        valueMax: n
      }, C = e.scaleSteps || a.value.style.chart.scale.ticks;
      let v;
      e.autoScaling ? v = we(c.valueMin, c.valueMax, C) : v = we(c.valueMin < 0 ? c.valueMin : 0, c.valueMax <= 0 ? 0 : c.valueMax, C);
      const y = u.value.stacked ? l.value.height * (1 - e.cumulatedStackRatio) : 0, N = u.value.stacked ? l.value.height / a.value.style.chart.stackGap : 0, S = u.value.stacked ? l.value.height * e.stackRatio - N : l.value.height, R = v.min < 0 ? Math.abs(v.min) : 0;
      let H;
      e.autoScaling && u.value.stacked && n <= 0 ? H = l.value.bottom - y - S : H = l.value.bottom - y - S * (R / (v.max + R));
      const K = v.ticks.map((O, Oa) => ({
        y: l.value.bottom - y - S * (Oa / (v.ticks.length - 1)),
        x: l.value.left - 8,
        value: O
      })), Q = ya({
        hasAutoScale: u.value.stacked && e.autoScaling,
        series: e.series,
        min: u.value.stacked ? o : p.value.min,
        max: u.value.stacked ? n : p.value.max,
        scale: u.value.stacked ? v : p.value.scale,
        yOffset: y,
        individualHeight: S,
        stackIndex: u.value.stacked ? t : null
      });
      return {
        ...e,
        coordinatesLine: Q,
        min: o,
        max: n,
        localScale: v,
        localZero: H,
        localMin: R,
        localYLabels: K,
        yOffset: y,
        individualHeight: S
      };
    })), r = i({
      start: 0,
      end: I.value
    });
    function Ye() {
      Be();
    }
    const B = i(null);
    async function Be() {
      (a.value.style.chart.zoom.startIndex !== null || a.value.style.chart.zoom.endIndex !== null) && B.value ? (a.value.style.chart.zoom.startIndex !== null && (await he(), await he(), B.value && B.value.setStartValue(a.value.style.chart.zoom.startIndex)), a.value.style.chart.zoom.endIndex !== null && (await he(), await he(), B.value && B.value.setEndValue(ga(a.value.style.chart.zoom.endIndex + 1)))) : (r.value = {
        start: 0,
        end: I.value
      }, Ie.value += 1);
    }
    function ga(e) {
      const t = I.value;
      return e > t ? t : e < 0 || a.value.style.chart.zoom.startIndex !== null && e < a.value.style.chart.zoom.startIndex ? a.value.style.chart.zoom.startIndex !== null ? a.value.style.chart.zoom.startIndex + 1 : 1 : e;
    }
    const pa = x(() => h.value.filter((e) => ["line", "plot", void 0].includes(e.type))), k = x(() => h.value.filter((e) => e.type === "bar"));
    function ma() {
      if (!T.value)
        return;
      const e = q.value.offsetWidth, t = q.value.offsetHeight;
      T.value.width = e * W.value * 2, T.value.height = t * W.value * 2, f.value = e * W.value * 2, P.value = t * W.value * 2, s.value.scale(W.value, W.value), J();
    }
    function ba() {
      if (s.value.clearRect(0, 0, 1e4, 1e4), s.value.fillStyle = a.value.style.chart.backgroundColor, s.value.fillRect(0, 0, l.value.canvasWidth, l.value.canvasHeight), u.value.stacked)
        a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength ? h.value.forEach((e) => {
          for (let t = 0; t < r.value.end - r.value.start + 1; t += 1)
            b(
              s.value,
              [
                {
                  x: l.value.left + l.value.slot * t,
                  y: l.value.bottom - e.yOffset - e.individualHeight
                },
                {
                  x: l.value.left + l.value.slot * t,
                  y: l.value.bottom - e.yOffset
                }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        }) : a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start >= a.value.style.chart.grid.y.verticalLines.hideUnderXLength && h.value.forEach((e) => {
          for (let t = r.value.start; t < r.value.end; t += 1)
            t % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 && b(
              s.value,
              [
                {
                  x: l.value.left + l.value.slot * (t - r.value.start) + l.value.slot / 2,
                  y: l.value.bottom - e.yOffset - e.individualHeight
                },
                {
                  x: l.value.left + l.value.slot * (t - r.value.start) + l.value.slot / 2,
                  y: l.value.bottom - e.yOffset
                }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        }), a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? h.value.forEach((e) => {
          e.localYLabels.forEach((t, o) => {
            o < e.localYLabels.length - 1 && ze(
              s.value,
              [
                { x: l.value.left, y: t.y },
                { x: l.value.right, y: t.y },
                { x: l.value.right, y: e.localYLabels[o + 1].y },
                { x: l.value.left, y: e.localYLabels[o + 1].y }
              ],
              {
                fillColor: o % 2 === 0 ? "transparent" : oe(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
                strokeColor: "transparent"
              }
            );
          });
        }) : h.value.forEach((e) => {
          e.localYLabels.slice(r.value.start, r.value.end).forEach((t) => {
            b(
              s.value,
              [
                { x: l.value.left, y: t.y },
                { x: l.value.right, y: t.y }
              ],
              {
                color: a.value.style.chart.grid.x.horizontalLines.color
              }
            );
          });
        })), a.value.style.chart.grid.zeroLine.show && h.value.forEach((e) => {
          b(
            s.value,
            [
              { x: l.value.left, y: e.localZero },
              { x: l.value.right, y: e.localZero }
            ],
            {
              color: a.value.style.chart.grid.zeroLine.color,
              lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
            }
          );
        }), a.value.style.chart.grid.y.axisLabels.show && h.value.forEach((e) => {
          b(
            s.value,
            [
              { x: l.value.left, y: l.value.bottom - e.yOffset },
              { x: l.value.left, y: l.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), b(
            s.value,
            [
              { x: l.value.right, y: l.value.bottom - e.yOffset },
              { x: l.value.right, y: l.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), e.localYLabels.forEach((t, o) => {
            D(
              s.value,
              le(
                a.value.style.chart.dataLabels.formatter,
                t.value,
                te({
                  p: e.prefix || a.value.style.chart.grid.y.axisLabels.prefix || "",
                  v: t.value,
                  s: e.suffix || a.value.style.chart.grid.y.axisLabels.suffix || "",
                  r: e.rounding || a.value.style.chart.grid.y.axisLabels.rounding || 0
                }),
                { datapoint: t, seriesIndex: o }
              ),
              t.x + a.value.style.chart.grid.y.axisLabels.offsetX,
              t.y,
              {
                align: "right",
                font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
                color: e.color
              }
            );
          });
        }), h.value.forEach((e) => {
          D(
            s.value,
            e.name,
            f.value / 35,
            l.value.bottom - e.yOffset - e.individualHeight / 2,
            {
              align: "center",
              rotation: -90,
              color: e.color,
              font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`
            }
          );
        });
      else {
        if (a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength)
          for (let e = 0; e < r.value.end - r.value.start + 1; e += 1)
            b(
              s.value,
              [
                { x: l.value.left + l.value.slot * e, y: l.value.top },
                { x: l.value.left + l.value.slot * e, y: l.value.bottom }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        else if (a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start >= a.value.style.chart.grid.y.verticalLines.hideUnderXLength)
          for (let e = r.value.start; e < r.value.end; e += 1)
            e % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 && b(
              s.value,
              [
                { x: l.value.left + l.value.slot * (e - r.value.start) + l.value.slot / 2, y: l.value.top },
                { x: l.value.left + l.value.slot * (e - r.value.start) + l.value.slot / 2, y: l.value.bottom }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? p.value.yLabels.forEach((e, t) => {
          t < p.value.yLabels.length - 1 && ze(
            s.value,
            [
              { x: l.value.left, y: e.y },
              { x: l.value.right, y: e.y },
              { x: l.value.right, y: p.value.yLabels[t + 1].y },
              { x: l.value.left, y: p.value.yLabels[t + 1].y }
            ],
            {
              fillColor: t % 2 === 0 ? "transparent" : oe(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
              strokeColor: "transparent"
            }
          );
        }) : p.value.yLabels.forEach((e) => {
          b(
            s.value,
            [
              { x: l.value.left, y: e.y },
              { x: l.value.right, y: e.y }
            ],
            {
              color: a.value.style.chart.grid.x.horizontalLines.color
            }
          );
        })), a.value.style.chart.grid.y.showAxis && b(
          s.value,
          [
            { x: l.value.left, y: l.value.top },
            { x: l.value.left, y: l.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.y.axisColor,
            lineWidth: a.value.style.chart.grid.y.axisThickness
          }
        ), a.value.style.chart.grid.x.showAxis && b(
          s.value,
          [
            { x: l.value.left, y: l.value.bottom },
            { x: l.value.right, y: l.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.x.axisColor,
            lineWidth: a.value.style.chart.grid.x.axisThickness
          }
        ), a.value.style.chart.grid.zeroLine.show && b(
          s.value,
          [
            { x: l.value.left, y: p.value.zero },
            { x: l.value.right, y: p.value.zero }
          ],
          {
            color: a.value.style.chart.grid.zeroLine.color,
            lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
          }
        ), a.value.style.chart.grid.y.axisLabels.show && p.value.yLabels.forEach((e, t) => {
          D(
            s.value,
            le(
              a.value.style.chart.dataLabels.formatter,
              e.value,
              te({
                p: a.value.style.chart.grid.y.axisLabels.prefix || "",
                v: e.value,
                s: a.value.style.chart.grid.y.axisLabels.suffix || "",
                r: a.value.style.chart.grid.y.axisLabels.rounding || 0
              }),
              { datapoint: e, seriesIndex: t }
            ),
            e.x + a.value.style.chart.grid.y.axisLabels.offsetX,
            e.y,
            {
              align: "right",
              font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.grid.y.axisLabels.color
            }
          );
        });
      }
      a.value.style.chart.grid.y.axisName && D(
        s.value,
        a.value.style.chart.grid.y.axisName,
        f.value - f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio * 1.2,
        l.value.bottom - l.value.height / 2,
        {
          font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center",
          rotation: 90
        }
      ), a.value.style.chart.grid.x.axisName && D(
        s.value,
        a.value.style.chart.grid.x.axisName,
        f.value / 2,
        P.value,
        {
          font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center"
        }
      );
    }
    function xa(e) {
      for (let t = 0; t < e.coordinatesLine.length; t += 1) {
        const o = (d.value === t ? f.value / 150 : a.value.style.chart.line.plots.show ? f.value / 200 : 0) * a.value.style.chart.line.plots.radiusRatio;
        ra(
          s.value,
          { x: e.coordinatesLine[t].x, y: e.coordinatesLine[t].y },
          o,
          {
            color: a.value.style.chart.backgroundColor,
            fillStyle: e.color
          }
        );
      }
    }
    function La(e) {
      for (let t = 0; t < e.coordinatesLine.length; t += 1)
        D(
          s.value,
          le(
            a.value.style.chart.dataLabels.formatter,
            e.coordinatesLine[t].value,
            te({
              p: e.prefix || "",
              v: e.coordinatesLine[t].value,
              s: e.suffix || "",
              r: e.rounding || 0
            }),
            { datapoint: e.coordinatesLine[t], seriesIndex: t }
          ),
          e.coordinatesLine[t].x,
          e.coordinatesLine[t].y + a.value.style.chart.dataLabels.offsetY,
          {
            align: "center",
            font: `${Math.round(f.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
            strokeColor: a.value.style.chart.backgroundColor,
            lineWidth: 0.8
          }
        );
    }
    function ka() {
      for (let e = r.value.start; e < r.value.end; e += 1)
        (r.value.end - r.value.start < a.value.style.chart.grid.y.timeLabels.modulo || r.value.end - r.value.start >= a.value.style.chart.grid.y.timeLabels.modulo && (e % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 || e === d.value + r.value.start)) && D(
          s.value,
          a.value.style.chart.grid.y.timeLabels.values[e] || e + 1,
          l.value.left + l.value.slot * (e - r.value.start) + l.value.slot / 2,
          l.value.bottom + f.value / a.value.style.chart.grid.y.timeLabels.offsetY,
          {
            align: a.value.style.chart.grid.y.timeLabels.rotation === 0 ? "center" : a.value.style.chart.grid.y.timeLabels.rotation > 0 ? "left" : "right",
            font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.timeLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: oe(a.value.style.chart.grid.y.timeLabels.color, d.value !== null ? d.value + r.value.start === e ? 100 : 20 : 100),
            rotation: a.value.style.chart.grid.y.timeLabels.rotation
          }
        );
    }
    function Ve() {
      b(
        s.value,
        [
          { x: l.value.left + l.value.slot * d.value + l.value.slot / 2, y: l.value.top },
          { x: l.value.left + l.value.slot * d.value + l.value.slot / 2, y: l.value.bottom }
        ],
        {
          color: a.value.style.chart.selector.color,
          lineDash: a.value.style.chart.selector.dashed ? [8, 8] : [0, 0],
          lineWidth: 2
        }
      );
    }
    function Ca() {
      M.value && b(
        s.value,
        [
          { x: l.value.left, y: M.value },
          { x: l.value.right, y: M.value }
        ],
        {
          color: a.value.style.chart.selector.color,
          lineDash: a.value.style.chart.selector.dashed ? [8, 8] : [0, 0],
          lineWidth: 2
        }
      );
    }
    function wa() {
      k.value.forEach((e, t) => {
        for (let o = 0; o < e.coordinatesLine.length; o += 1)
          ze(
            s.value,
            [
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (u.value.stacked ? 0 : l.value.slot / k.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * k.value.length) * t)),
                y: u.value.stacked ? e.localZero : p.value.zero
              },
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (u.value.stacked ? 0 : l.value.slot / k.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * k.value.length) * t)) + l.value.slot * 0.8 / (u.value.stacked ? 1 : k.value.length),
                y: u.value.stacked ? e.localZero : p.value.zero
              },
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (u.value.stacked ? 0 : l.value.slot / k.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * k.value.length) * t)) + l.value.slot * 0.8 / (u.value.stacked ? 1 : k.value.length),
                y: e.coordinatesLine[o].y
              },
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (u.value.stacked ? 0 : l.value.slot / k.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * k.value.length) * t)),
                y: e.coordinatesLine[o].y
              }
            ],
            {
              strokeColor: a.value.style.chart.backgroundColor,
              gradient: {
                type: "linear",
                start: {
                  x: e.coordinatesLine[o].x,
                  y: e.coordinatesLine[o].y
                },
                end: {
                  x: e.coordinatesLine[o].x,
                  y: u.value.stacked ? e.localZero : p.value.zero
                },
                stops: [
                  { offset: 0, color: e.color },
                  { offset: 1, color: Ja(e.color, 0.5) }
                ]
              }
            }
          ), u.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && D(
            s.value,
            le(
              a.value.style.chart.dataLabels.formatter,
              e.coordinatesLine[o].value,
              te({
                p: e.prefix || "",
                v: e.coordinatesLine[o].value,
                s: e.suffix || "",
                r: e.rounding || 0
              }),
              { datapoint: e.coordinatesLine[o], seriesIndex: o }
            ),
            l.value.left + l.value.slot * o + l.value.slot / 10 + (u.value.stacked ? 0 : l.value.slot / k.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * k.value.length) * t)) + l.value.slot * 0.4 / (u.value.stacked ? 1 : k.value.length),
            (e.coordinatesLine[o].value < 0 ? u.value.stacked ? e.localZero : p.value.zero : e.coordinatesLine[o].y) + a.value.style.chart.dataLabels.offsetY,
            {
              align: "center",
              font: `${Math.round(f.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
              strokeColor: a.value.style.chart.backgroundColor,
              lineWidth: 0.8
            }
          );
      });
    }
    function za(e) {
      e.useArea ? u.value.stacked ? ua(
        s.value,
        [{ x: e.coordinatesLine[0].x, y: e.localZero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: e.localZero }],
        {
          fillColor: oe(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : ua(
        s.value,
        [{ x: e.coordinatesLine[0].x, y: p.value.zero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: p.value.zero }],
        {
          fillColor: oe(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : b(s.value, e.coordinatesLine, {
        color: e.color,
        lineWidth: 3
      });
    }
    function Sa() {
      h.value.forEach((e, t) => {
        b(
          s.value,
          [
            { x: l.value.left, y: l.value.bottom - e.yOffset },
            { x: l.value.right, y: l.value.bottom - e.yOffset }
          ],
          {
            color: a.value.style.chart.grid.x.horizontalLines.color,
            lineWidth: 1
          }
        );
      });
    }
    function J() {
      ba(), A.value ? (d.value !== null && a.value.style.chart.selector.show && Ve(), wa(), u.value.stacked && a.value.style.chart.grid.x.showAxis && Sa(), pa.value.forEach((e) => {
        (e.type === "line" || !e.type) && za(e), X.value && (xa(e), u.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && La(e));
      }), ge.value = al(T.value)) : (ge.value && (s.value.clearRect(0, 0, 1e4, 1e4), s.value.drawImage(ge.value, 0, 0)), d.value !== null && a.value.style.chart.selector.show && Ve(), d.value !== null && h.value.forEach((e) => {
        if (e.type === "line" || !e.type || e.type === "plot") {
          if (!e.coordinatesLine[d.value]) return;
          e.coordinatesLine[d.value].x !== void 0 && e.coordinatesLine[d.value].y !== void 0 && ra(
            s.value,
            {
              x: e.coordinatesLine[d.value].x,
              y: e.coordinatesLine[d.value].y
            },
            f.value / 150 * a.value.style.chart.line.plots.radiusRatio,
            {
              color: a.value.style.chart.backgroundColor,
              fillStyle: e.color
            }
          );
        }
      })), a.value.style.chart.grid.y.timeLabels.show && ka(), a.value.style.chart.selector.show && Ca(), A.value = !1;
    }
    const ne = Ka(() => {
      X.value = !0, ma();
    }, I.value > 200 ? 10 : 1, !X.value);
    function $a(e) {
      const { left: t, top: o } = T.value.getBoundingClientRect(), n = e.clientX - t;
      if (M.value = (e.clientY - o) * 2, (M.value < l.value.top || M.value > l.value.bottom) && (M.value = null), n * 2 < l.value.left || n * 2 > l.value.right) {
        re.value = !1, d.value = null;
        return;
      }
      const c = n * 2 - l.value.left;
      if (d.value = Math.floor(c / l.value.slot), re.value = !0, !X.value) return;
      let C = "";
      const v = a.value.style.chart.tooltip.customFormat;
      oa(v) && qa(() => v({
        seriesIndex: d.value,
        datapoint: h.value.map((y) => ({
          shape: y.shape || null,
          name: y.name,
          color: y.color,
          type: y.type || "line",
          value: y.series.find((N, S) => S === d.value)
        })),
        series: h.value,
        config: a.value
      })) ? ue.value = v({
        seriesIndex: d.value,
        datapoint: h.value.map((y) => ({
          shape: y.shape || null,
          name: y.name,
          color: y.color,
          type: y.type || "line",
          value: y.series.find((N, S) => S === d.value)
        })),
        series: h.value,
        config: a.value
      }) : (a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[d.value] && (C += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${a.value.style.chart.tooltip.borderColor}; width:100%">${a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[d.value]}</div>`), C += fa.value.join(""), ue.value = C), X.value = !1;
    }
    F(() => d.value, (e) => {
      ne();
    }), F(() => r.value, (e) => {
      A.value = !0, J();
    }, {
      deep: !0
    }), F(() => u.value.showDataLabels, (e) => {
      A.value = !0, J();
    }), F(() => M.value, (e) => {
      e && J();
    }), F(() => u.value.stacked, (e) => {
      A.value = !0, X.value = !0, ne();
    });
    function Ia() {
      re.value = !1, d.value = null, ue.value = "", M.value = null, J();
    }
    const ie = i(null), ve = i(null);
    aa(() => {
      ke();
    });
    function ke() {
      if (Va(g.dataset) ? Za({
        componentName: "VueUiXyCanvas",
        type: "dataset"
      }) : T.value && (s.value = T.value.getContext("2d", { willReadFrequently: !0 })), a.value.responsive) {
        const e = Qa(() => {
          const { width: t, height: o } = el({
            chart: j.value,
            title: a.value.style.chart.title.text ? Me.value : null,
            legend: a.value.style.chart.legend.show ? Oe.value : null,
            slicer: a.value.style.chart.zoom.show && I.value > 1 ? Pe.value : null,
            source: Re.value
          });
          requestAnimationFrame(() => {
            Ae.value = `${t} / ${o}`;
          });
        });
        ie.value = new ResizeObserver(e), ie.value.observe(j.value.parentNode);
      }
      ve.value = new ResizeObserver((e) => {
        for (const t of e)
          t.contentBoxSize && q.value && (A.value = !0, ne());
      }), ve.value.observe(q.value), Be();
    }
    Ra(() => {
      ve.value && ve.value.disconnect(), ie.value && ie.value.disconnect();
    });
    function Ze(e) {
      ca("selectLegend", h.value.find((t) => t.absoluteIndex === e)), $.value.includes(e) ? $.value = $.value.filter((t) => t !== e) : $.value.push(e), A.value = !0, ne();
    }
    const Ge = x(() => Y.value.map((e, t) => ({
      ...e,
      name: e.name,
      color: ta(e.color) || We.value[t] || U[t] || U[t % U.length],
      shape: e.shape || "circle",
      prefix: e.prefix || "",
      suffix: e.suffix || "",
      rounding: e.rounding || 0
    })).map((e) => ({
      ...e,
      opacity: $.value.includes(e.absoluteIndex) ? 0.5 : 1,
      segregate: () => Ze(e.absoluteIndex),
      isSegregated: $.value.includes(e.absoluteIndex)
    }))), Ta = x(() => ({
      cy: "donut-div-legend",
      backgroundColor: a.value.style.chart.legend.backgroundColor,
      color: a.value.style.chart.legend.color,
      fontSize: a.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: a.value.style.chart.legend.bold ? "bold" : ""
    })), ce = x(() => {
      const e = [""].concat(h.value.map((c) => c.name)).concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>');
      let t = [];
      for (let c = 0; c < I.value; c += 1) {
        const C = h.value.map((v) => v.series[c] ?? 0).reduce((v, y) => v + y, 0);
        t.push([a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[c] ?? c + 1].concat(h.value.map((v) => (v.series[c] ?? 0).toFixed(a.value.table.rounding))).concat((C ?? 0).toFixed(a.value.table.rounding)));
      }
      const o = {
        th: {
          backgroundColor: a.value.table.th.backgroundColor,
          color: a.value.table.th.color,
          outline: a.value.table.th.outline
        },
        td: {
          backgroundColor: a.value.table.td.backgroundColor,
          color: a.value.table.td.color,
          outline: a.value.table.td.outline
        },
        breakpoint: a.value.table.responsiveBreakpoint
      }, n = [a.value.table.columnNames.period].concat(h.value.map((c) => c.name)).concat(a.value.table.columnNames.total);
      return { head: e, body: t.slice(0, r.value.end - r.value.start), config: o, colNames: n };
    }), je = x(() => {
      if (h.value.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const e = h.value.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), t = [];
      for (let o = r.value.start; o < r.value.end; o += 1) {
        const n = [a.value.style.chart.grid.y.timeLabels.values[o] || o + 1];
        h.value.forEach((c) => {
          n.push(Number((c.series[o] || 0).toFixed(a.value.table.rounding)));
        }), t.push(n);
      }
      return { head: e, body: t };
    });
    function qe() {
      const e = [[a.value.style.chart.title.text], [a.value.style.chart.title.subtitle.text], [""]], t = ["", ...je.value.head.map((C) => C.label)], o = je.value.body, n = e.concat([t]).concat(o), c = Ga(n);
      ja({ csvContent: c, title: a.value.style.chart.title.text || "vue-ui-xy-canvas" });
    }
    function Ma() {
      return h.value;
    }
    function Je() {
      u.value.showTable = !u.value.showTable;
    }
    function Ke() {
      u.value.showDataLabels = !u.value.showDataLabels;
    }
    function Qe() {
      u.value.stacked = !u.value.stacked;
    }
    function ea() {
      u.value.showTooltip = !u.value.showTooltip;
    }
    const de = i(!1);
    function Ce() {
      de.value = !de.value;
    }
    return na({
      getData: Ma,
      generateCsv: qe,
      generatePdf: _e,
      generateImage: Ue,
      toggleTable: Je,
      toggleLabels: Ke,
      toggleStack: Qe,
      toggleTooltip: ea,
      toggleAnnotator: Ce
    }), (e, t) => (w(), ee("div", {
      style: V(`width:100%; position:relative; ${a.value.responsive ? "height: 100%" : ""}`),
      ref_key: "xy",
      ref: j,
      id: `xy_canvas_${fe.value}`,
      class: Fa(`vue-ui-donut ${se.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      onMouseenter: t[5] || (t[5] = () => z(Fe)(!0)),
      onMouseleave: t[6] || (t[6] = () => z(Fe)(!1))
    }, [
      a.value.style.chart.title.text ? (w(), ee("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: Me,
        style: V(`width:100%;background:${a.value.style.chart.backgroundColor};`)
      }, [
        (w(), E(ol, {
          key: `title_${pe.value}`,
          config: {
            title: {
              cy: "xy-canvas-title",
              ...a.value.style.chart.title
            },
            subtitle: {
              cy: "xy-canvas-subtitle",
              ...a.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : _("", !0),
      a.value.userOptions.show && xe.value && (z(Ee) || z(Le)) ? (w(), E(sl, {
        ref: "details",
        key: `user_option_${Te.value}`,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        isPrinting: z(Ne),
        isImaging: z(He),
        uid: fe.value,
        hasTooltip: a.value.userOptions.buttons.tooltip && a.value.style.chart.tooltip.show,
        hasPdf: a.value.userOptions.buttons.pdf,
        hasImg: a.value.userOptions.buttons.img,
        hasXls: a.value.userOptions.buttons.csv,
        hasLabel: a.value.userOptions.buttons.labels,
        hasStack: Se.dataset.length > 1 && a.value.userOptions.buttons.stack,
        hasFullscreen: a.value.userOptions.buttons.fullscreen,
        hasTable: r.value.end - r.value.start < 200 && a.value.userOptions.buttons.table,
        isFullscreen: se.value,
        isTooltip: u.value.showTooltip,
        isStacked: u.value.stacked,
        titles: { ...a.value.userOptions.buttonTitles },
        chartElement: j.value,
        position: a.value.userOptions.position,
        hasAnnotator: a.value.userOptions.buttons.annotator,
        isAnnotation: de.value,
        onToggleFullscreen: ha,
        onGeneratePdf: z(_e),
        onGenerateCsv: qe,
        onGenerateImage: z(Ue),
        onToggleTable: Je,
        onToggleLabels: Ke,
        onToggleStack: Qe,
        onToggleTooltip: ea,
        onToggleAnnotator: Ce,
        style: V({
          visibility: z(Ee) ? z(Le) ? "visible" : "hidden" : "visible"
        })
      }, Ea({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: m(() => [
            L(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            L(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            L(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            L(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            L(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: m(() => [
            L(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionStack ? {
          name: "optionStack",
          fn: m(() => [
            L(e.$slots, "optionStack", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: o, isFullscreen: n }) => [
            L(e.$slots, "optionFullscreen", Z(G({ toggleFullscreen: o, isFullscreen: n })), void 0, !0)
          ]),
          key: "7"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: m(({ toggleAnnotator: o, isAnnotator: n }) => [
            L(e.$slots, "optionAnnotator", Z(G({ toggleAnnotator: o, isAnnotator: n })), void 0, !0)
          ]),
          key: "8"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasLabel", "hasStack", "hasFullscreen", "hasTable", "isFullscreen", "isTooltip", "isStacked", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : _("", !0),
      ae("div", {
        class: "vue-ui-xy-canvas",
        style: V(`position: relative; aspect-ratio: ${Ae.value}`),
        ref_key: "container",
        ref: q
      }, [
        xe.value ? (w(), ee("canvas", {
          key: 0,
          ref_key: "canvas",
          ref: T,
          style: { width: "100%", height: "100%" },
          onMousemove: t[0] || (t[0] = (o) => $a(o)),
          onMouseleave: Ia
        }, null, 544)) : (w(), E(vl, {
          key: 1,
          config: {
            type: "line",
            style: {
              backgroundColor: a.value.style.chart.backgroundColor,
              line: {
                axis: {
                  color: "#CCCCCC"
                },
                path: {
                  color: "#CCCCCC",
                  strokeWidth: 0.5
                }
              }
            }
          }
        }, null, 8, ["config"])),
        Da(ll, {
          show: u.value.showTooltip && re.value,
          backgroundColor: a.value.style.chart.tooltip.backgroundColor,
          color: a.value.style.chart.tooltip.color,
          fontSize: a.value.style.chart.tooltip.fontSize,
          borderRadius: a.value.style.chart.tooltip.borderRadius,
          borderColor: a.value.style.chart.tooltip.borderColor,
          borderWidth: a.value.style.chart.tooltip.borderWidth,
          position: a.value.style.chart.tooltip.position,
          offsetY: a.value.style.chart.tooltip.offsetY,
          parent: T.value,
          content: ue.value,
          isFullscreen: se.value,
          backgroundOpacity: a.value.style.chart.tooltip.backgroundOpacity,
          isCustom: z(oa)(a.value.style.chart.tooltip.customFormat)
        }, {
          "tooltip-before": m(() => [
            L(e.$slots, "tooltip-before", Z(G({ ...$e.value })), void 0, !0)
          ]),
          "tooltip-after": m(() => [
            L(e.$slots, "tooltip-after", Z(G({ ...$e.value })), void 0, !0)
          ]),
          _: 3
        }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "position", "offsetY", "parent", "content", "isFullscreen", "backgroundOpacity", "isCustom"])
      ], 4),
      ae("div", {
        ref_key: "chartSlicer",
        ref: Pe,
        style: V(`width:100%;background:${a.value.style.chart.backgroundColor}`),
        "data-html2canvas-ignore": ""
      }, [
        a.value.style.chart.zoom.show && I.value > 1 ? (w(), E(rl, {
          ref_key: "slicerComponent",
          ref: B,
          key: `slicer_${Ie.value}`,
          background: a.value.style.chart.zoom.color,
          borderColor: a.value.style.chart.backgroundColor,
          fontSize: a.value.style.chart.zoom.fontSize,
          useResetSlot: a.value.style.chart.zoom.useResetSlot,
          labelLeft: a.value.style.chart.grid.y.timeLabels.values[r.value.start] ? a.value.style.chart.grid.y.timeLabels.values[r.value.start] : "",
          labelRight: a.value.style.chart.grid.y.timeLabels.values[r.value.end - 1] ? a.value.style.chart.grid.y.timeLabels.values[r.value.end - 1] : "",
          textColor: a.value.style.chart.color,
          inputColor: a.value.style.chart.zoom.color,
          selectColor: a.value.style.chart.zoom.highlightColor,
          max: I.value,
          min: 0,
          valueStart: r.value.start,
          valueEnd: r.value.end,
          start: r.value.start,
          "onUpdate:start": t[1] || (t[1] = (o) => r.value.start = o),
          end: r.value.end,
          "onUpdate:end": t[2] || (t[2] = (o) => r.value.end = o),
          refreshStartPoint: a.value.style.chart.zoom.startIndex !== null ? a.value.style.chart.zoom.startIndex : 0,
          refreshEndPoint: a.value.style.chart.zoom.endIndex !== null ? a.value.style.chart.zoom.endIndex + 1 : I.value,
          enableRangeHandles: a.value.style.chart.zoom.enableRangeHandles,
          enableSelectionDrag: a.value.style.chart.zoom.enableSelectionDrag,
          onReset: Ye
        }, {
          "reset-action": m(({ reset: o }) => [
            L(e.$slots, "reset-action", Z(G({ reset: o })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag"])) : _("", !0)
      ], 4),
      ae("div", {
        ref_key: "chartLegend",
        ref: Oe
      }, [
        a.value.style.chart.legend.show && xe.value ? (w(), E(tl, {
          legendSet: Ge.value,
          config: Ta.value,
          key: `legend_${be.value}`,
          onClickMarker: t[3] || (t[3] = ({ i: o }) => Ze(o))
        }, {
          item: m(({ legend: o, index: n }) => [
            ae("div", {
              onClick: (c) => o.segregate(),
              style: V(`opacity:${$.value.includes(n) ? 0.5 : 1}`)
            }, la(o.name), 13, fl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : L(e.$slots, "legend", {
          key: 1,
          legend: Ge.value
        }, void 0, !0)
      ], 512),
      e.$slots.watermark ? (w(), ee("div", gl, [
        L(e.$slots, "watermark", Z(G({ isPrinting: z(Ne) || z(He) })), void 0, !0)
      ])) : _("", !0),
      e.$slots.source ? (w(), ee("div", {
        key: 3,
        ref_key: "source",
        ref: Re,
        dir: "auto"
      }, [
        L(e.$slots, "source", {}, void 0, !0)
      ], 512)) : _("", !0),
      r.value.end - r.value.start < 200 ? (w(), E(nl, {
        key: 4,
        hideDetails: "",
        config: {
          open: u.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          },
          head: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (w(), E(il, {
            key: `table_${me.value}`,
            colNames: ce.value.colNames,
            head: ce.value.head,
            body: ce.value.body,
            config: ce.value.config,
            title: `${a.value.style.chart.title.text}${a.value.style.chart.title.subtitle.text ? ` : ${a.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: t[4] || (t[4] = (o) => u.value.showTable = !1)
          }, {
            th: m(({ th: o }) => [
              ae("div", { innerHTML: o }, null, 8, pl)
            ]),
            td: m(({ td: o }) => [
              Aa(la(o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : _("", !0),
      a.value.userOptions.buttons.annotator && h.value.length ? (w(), E(cl, {
        key: 5,
        parent: j.value,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        active: de.value,
        onClose: Ce
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : _("", !0)
    ], 46, yl));
  }
}, Fl = /* @__PURE__ */ hl(ml, [["__scopeId", "data-v-5cdf46ea"]]);
export {
  Fl as default
};
