import { useSlots as it, computed as _, ref as d, onMounted as vt, onBeforeUnmount as ct, watch as Ue, createElementBlock as u, openBlock as o, unref as n, normalizeStyle as z, normalizeClass as ce, createBlock as U, createCommentVNode as i, renderSlot as b, createElementVNode as p, createVNode as de, createSlots as je, withCtx as $, normalizeProps as K, guardReactiveProps as Q, Fragment as g, renderList as F, mergeProps as We, toDisplayString as C, createTextVNode as He, nextTick as dt } from "vue";
import { u as ht, o as yt, e as Ee, g as ft, c as pt, b as gt, d as Re, p as j, m as bt, H as mt, f as O, X as wt, s as Z, w as kt, j as _t, I as L, i as A, k as ee, n as w, t as xt, a as $t, q as Ct, r as Pt, x as St } from "./index-CokOzopo.js";
import { t as Ft, u as Lt } from "./useResponsive-CoxXLe23.js";
import { _ as Tt } from "./Title-_eGGQuGI.js";
import { u as zt, U as Ot } from "./usePrinter-BzR_jvGv.js";
import { D as Yt } from "./DataTable-Cm5zBJcA.js";
import { _ as At } from "./Tooltip-D5tlGuh0.js";
import { L as Nt } from "./Legend-DX8CljeB.js";
import Xt from "./vue-ui-skeleton-C3Lk5ZAd.js";
import It from "./vue-ui-accordion-De733ske.js";
import { u as qe } from "./useNestedProp--JNGbFip.js";
import { _ as Dt } from "./PackageVersion-BPWkS_lI.js";
import { P as Mt } from "./PenAndPaper-BcMwzhXy.js";
import { u as Bt } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as Vt } from "./Shape-ijc_P0Zk.js";
import { _ as Gt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ut = ["id"], jt = ["xmlns", "viewBox"], Wt = ["width", "height"], Ht = { key: 1 }, Et = ["id"], Rt = ["stop-color"], qt = ["offset", "stop-color"], Jt = ["offset", "stop-color"], Kt = ["stop-color"], Qt = { key: 2 }, Zt = ["id", "cx", "cy"], el = ["stop-color", "stop-opacity"], tl = ["stop-color"], ll = ["id"], al = ["id"], ol = ["id"], ul = ["flood-color"], sl = ["id"], nl = ["flood-color"], rl = ["d", "stroke", "filter"], il = ["x1", "y1", "x2", "y2", "stroke", "filter"], vl = ["cx", "cy", "r", "fill", "filter"], cl = { key: 6 }, dl = ["stroke", "d"], hl = { key: 0 }, yl = ["d", "fill", "stroke", "stroke-width", "filter"], fl = ["d", "fill", "stroke", "stroke-width", "filter"], pl = { key: 0 }, gl = ["stroke", "d"], bl = { key: 0 }, ml = ["d", "stroke", "stroke-width", "filter"], wl = { key: 1 }, kl = ["d", "fill", "stroke", "stroke-width", "filter"], _l = ["d", "fill", "stroke", "stroke-width", "filter"], xl = { key: 1 }, $l = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Cl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Pl = ["cx", "cy", "r", "stroke"], Sl = ["cx", "cy", "r", "fill"], Fl = { key: 0 }, Ll = ["d", "fill", "onMouseenter", "onClick"], Tl = { key: 1 }, zl = ["cx", "cy", "r", "fill"], Ol = ["x", "y", "fill", "font-size"], Yl = ["x", "y", "fill", "font-size"], Al = ["x", "y", "fill", "font-size"], Nl = ["x", "y", "fill", "font-size"], Xl = ["filter"], Il = { key: 0 }, Dl = ["x", "y"], Ml = { key: 1 }, Bl = ["cx", "cy", "fill", "stroke", "filter", "onClick"], Vl = ["cx", "cy", "fill", "stroke", "filter", "onClick"], Gl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Ul = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], jl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Wl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Hl = { key: 2 }, El = ["x", "y", "width"], Rl = ["x", "y", "width"], ql = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Jl = ["onClick"], Kl = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, Ql = { key: 1 }, Zl = ["innerHTML"], ea = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(Je, { expose: Ke, emit: Qe }) {
    const { vue_ui_donut: Ze } = ht(), et = it(), N = Je, R = _({
      get() {
        return !!N.dataset && N.dataset.length;
      },
      set(l) {
        return l;
      }
    }), W = d(null), he = d(null), ye = d(null), te = d(null), fe = d(null), pe = d(null), ge = d(0), be = d(0), me = d(0);
    vt(() => {
      we();
    }), ct(() => {
      te.value && te.value.disconnect();
    });
    function we() {
      if (yt(N.dataset) ? Ee({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : N.dataset.forEach((l, r) => {
        ft({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          R.value = !1, Ee({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: r
          });
        });
      }), e.value.responsive) {
        const l = Ft(() => {
          const { width: r, height: t } = Lt({
            chart: W.value,
            title: e.value.style.chart.title.text ? he.value : null,
            legend: e.value.style.chart.legend.show ? ye.value : null,
            source: fe.value,
            noTitle: pe.value
          });
          requestAnimationFrame(() => {
            s.value.width = r, s.value.height = t;
          });
        });
        te.value = new ResizeObserver(l), te.value.observe(W.value.parentNode);
      }
    }
    const y = d(pt()), tt = d(null), le = d(!1), ue = d(""), P = d(null), ke = d(0);
    function _e() {
      const l = qe({
        userConfig: N.config,
        defaultConfig: Ze
      });
      return l.theme ? {
        ...qe({
          userConfig: $t.vue_ui_donut[l.theme] || N.config,
          defaultConfig: l
        }),
        customPalette: xt[l.theme] || j
      } : l;
    }
    const e = _({
      get: () => _e(),
      set: (l) => l
    }), { userOptionsVisible: se, setUserOptionsVisibility: xe, keepUserOptionState: $e } = Bt({ config: e.value });
    Ue(() => N.config, (l) => {
      e.value = _e(), se.value = !e.value.userOptions.showOnChartHover, we(), ge.value += 1, be.value += 1, me.value += 1, f.value.dataLabels.show = e.value.style.chart.layout.labels.dataLabels.show, f.value.showTable = e.value.table.show, f.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const { isPrinting: Ce, isImaging: Pe, generatePdf: Se, generateImage: Fe } = zt({
      elementId: `donut__${y.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut"
    }), lt = _(() => e.value.userOptions.show && !e.value.style.chart.title.text), Le = _(() => gt(e.value.customPalette)), f = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), s = d({
      height: 360,
      width: 512
    }), q = _(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, r = s.value.width * l, t = r > x.value ? x.value : r;
      return t < 24 ? 24 : t;
    }), Te = Qe, B = _(() => N.dataset.map((l, r) => ({
      name: l.name,
      color: Re(l.color) || Le.value[r] || j[r] || j[r % j.length],
      value: l.values.reduce((t, a) => t + a, 0),
      absoluteValues: l.values,
      comment: l.comment || "",
      patternIndex: r
    }))), T = d(B.value);
    Ue(() => B.value, (l) => T.value = l);
    function at() {
      return B.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const X = d([]), ze = d(null), Oe = d(null), V = d(!1);
    function Ye(l) {
      const r = B.value.find((v, m) => m === l), t = T.value.find((v, m) => m === l);
      let a = t.value;
      if (X.value.includes(l)) {
        let m = function() {
          a > v ? (cancelAnimationFrame(ze.value), T.value = T.value.map((k, ve) => l === ve ? {
            ...k,
            value: v
          } : k), V.value = !1) : (V.value = !0, a += v * 0.025, T.value = T.value.map((k, ve) => l === ve ? {
            ...k,
            value: a
          } : k), ze.value = requestAnimationFrame(m));
        };
        X.value = X.value.filter((k) => k !== l);
        const v = r.value;
        m();
      } else if (X.value.length < B.value.length - 1) {
        let v = function() {
          a < t.value / 100 ? (cancelAnimationFrame(Oe.value), X.value.push(l), T.value = T.value.map((m, k) => l === k ? {
            ...m,
            value: 0
          } : m), V.value = !1) : (V.value = !0, a /= 1.1, T.value = T.value.map((m, k) => l === k ? {
            ...m,
            value: a
          } : m), Oe.value = requestAnimationFrame(v));
        };
        v();
      }
      Te("selectLegend", I.value.map((v) => ({
        name: v.name,
        color: v.color,
        value: v.value
      })));
    }
    const I = _(() => (T.value.forEach((l, r) => {
      if ([null, void 0].includes(l.values))
        return {
          ...l,
          values: []
        };
    }), T.value.map((l, r) => ({
      ...l,
      seriesIndex: r
    })).filter((l, r) => !X.value.includes(r)))), Ae = _(() => N.dataset.map((l, r) => ({
      name: l.name,
      color: Re(l.color) || Le.value[r] || j[r] || j[r % j.length],
      value: (l.values || []).reduce((t, a) => t + a, 0),
      shape: "circle",
      patternIndex: r
    })).map((l, r) => ({
      ...l,
      proportion: l.value / N.dataset.map((t) => (t.values || []).reduce((a, v) => a + v, 0)).reduce((t, a) => t + a, 0),
      opacity: X.value.includes(r) ? 0.5 : 1,
      segregate: () => !V.value && Ye(r),
      isSegregated: X.value.includes(r)
    }))), ot = _(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), x = _(() => {
      const l = Math.min(s.value.width / 3, s.value.height / 3);
      return l < 55 ? 55 : l;
    }), h = _(() => bt({ series: I.value }, s.value.width / 2, s.value.height / 2, x.value, x.value, 1.99999, 2, 1, 360, 105.25, q.value)), c = _(() => {
      const l = Math.max(...I.value.map((t) => t.value)), r = I.value.map((t) => t.value / l);
      return mt({
        series: r,
        center: {
          x: s.value.width / 2,
          y: s.value.height / 2
        },
        maxRadius: Math.min(s.value.width, s.value.height) / 3
      });
    });
    function H(l) {
      return l.x > s.value.width / 2 + 6 ? "start" : l.x < s.value.width / 2 - 6 ? "end" : "middle";
    }
    function ut(l) {
      return l.middlePoint.y > s.value.height / 2 ? L({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 100, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y : L({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 0, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y - 100;
    }
    function Y(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function ne(l, r) {
      const t = l.value / st(r);
      return isNaN(t) ? 0 : A(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        O({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function st(l) {
      return [...l].map((r) => r.value).reduce((r, t) => r + t, 0);
    }
    const S = _(() => I.value.map((l) => l.value).reduce((l, r) => l + r, 0)), Ne = _(() => S.value / I.value.length), Xe = _(() => (l) => V.value ? l.proportion * 100 : l.value / S.value * 100), re = d(null), J = d(!1);
    function Ie({ datapoint: l, relativeIndex: r, seriesIndex: t, show: a = !1 }) {
      re.value = { datapoint: l, seriesIndex: t, config: e.value, series: B.value }, le.value = a, P.value = r;
      let v = "";
      const m = e.value.style.chart.tooltip.customFormat;
      if (J.value = !1, St(m))
        try {
          const k = m({
            seriesIndex: t,
            datapoint: l,
            series: B.value,
            config: e.value
          });
          typeof k == "string" && (ue.value = k, J.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), J.value = !1;
        }
      if (!J.value) {
        if (v += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, v += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 60 60" height="14" width="14"><circle cx="30" cy="30" r="30" stroke="none" fill="${l.color}"/>${et.pattern ? `<circle cx="30" cy="30" r="30" stroke="none" fill="url(#pattern_${y.value}_${t})"/>` : ""}</svg>`, e.value.style.chart.tooltip.showValue && (v += `<b>${A(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          O({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: r,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const k = A(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            O({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: r,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? v += `<span>(${k})</span></div>` : v += `<b>${k}</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (v += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), ue.value = `<div>${v}</div>`;
      }
    }
    function G(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(P.value) && P.value !== l ? `url(#blur_${y.value})` : "";
    }
    const D = _(() => {
      const l = I.value.map((t) => ({
        name: t.name,
        color: t.color
      })), r = I.value.map((t) => t.value);
      return { head: l, body: r };
    });
    function De() {
      dt(() => {
        const l = D.value.head.map((a, v) => [[
          a.name
        ], [D.value.body[v]], [isNaN(D.value.body[v] / S.value) ? "-" : D.value.body[v] / S.value * 100]]), r = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = Ct(r);
        Pt({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const ae = _(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        O({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: S.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], r = D.value.head.map((v, m) => [
        {
          color: v.color,
          name: v.name
        },
        D.value.body[m],
        isNaN(D.value.body[m] / S.value) ? "-" : (D.value.body[m] / S.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: r,
        config: t
      };
    }), E = d(!1);
    function nt(l) {
      E.value = l, ke.value += 1;
    }
    const Me = _(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function rt(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((r) => "-").join("");
    }
    function M(l, r) {
      Te("selectDatapoint", { datapoint: l, index: r });
    }
    function Be() {
      f.value.showTable = !f.value.showTable;
    }
    function Ve() {
      f.value.dataLabels.show = !f.value.dataLabels.show;
    }
    function Ge() {
      f.value.showTooltip = !f.value.showTooltip;
    }
    const oe = d(!1);
    function ie() {
      oe.value = !oe.value;
    }
    return Ke({
      getData: at,
      generatePdf: Se,
      generateCsv: De,
      generateImage: Fe,
      toggleTable: Be,
      toggleLabels: Ve,
      toggleTooltip: Ge,
      toggleAnnotator: ie
    }), (l, r) => (o(), u("div", {
      ref_key: "donutChart",
      ref: W,
      class: ce(`vue-ui-donut ${E.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: z(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${y.value}`,
      onMouseenter: r[6] || (r[6] = () => n(xe)(!0)),
      onMouseleave: r[7] || (r[7] = () => n(xe)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (o(), U(Mt, {
        key: 0,
        parent: W.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: oe.value,
        onClose: ie
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : i("", !0),
      b(l.$slots, "userConfig", {}, void 0, !0),
      lt.value ? (o(), u("div", {
        key: 1,
        ref_key: "noTitle",
        ref: pe,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : i("", !0),
      e.value.style.chart.title.text ? (o(), u("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: he,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), U(Tt, {
          key: `title_${ge.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : i("", !0),
      e.value.userOptions.show && R.value && (n($e) || n(se)) ? (o(), U(Ot, {
        ref_key: "details",
        ref: tt,
        key: `user_option_${ke.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: n(Ce),
        isImaging: n(Pe),
        uid: y.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: E.value,
        chartElement: W.value,
        position: e.value.userOptions.position,
        isTooltip: f.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: oe.value,
        onToggleFullscreen: nt,
        onGeneratePdf: n(Se),
        onGenerateCsv: De,
        onGenerateImage: n(Fe),
        onToggleTable: Be,
        onToggleLabels: Ve,
        onToggleTooltip: Ge,
        onToggleAnnotator: ie,
        style: z({
          visibility: n($e) ? n(se) ? "visible" : "hidden" : "visible"
        })
      }, je({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: $(() => [
            b(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: $(() => [
            b(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: $(() => [
            b(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: $(() => [
            b(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: $(() => [
            b(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: $(() => [
            b(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: $(({ toggleFullscreen: t, isFullscreen: a }) => [
            b(l.$slots, "optionFullscreen", K(Q({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: $(({ toggleAnnotator: t, isAnnotator: a }) => [
            b(l.$slots, "optionAnnotator", K(Q({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : i("", !0),
      R.value ? (o(), u("svg", {
        key: 4,
        xmlns: n(wt),
        class: ce({ "vue-data-ui-fullscreen--on": E.value, "vue-data-ui-fulscreen--off": !E.value }),
        viewBox: `0 0 ${s.value.width <= 0 ? 10 : s.value.width} ${s.value.height <= 0 ? 10 : s.value.height}`,
        style: z(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        de(Dt),
        l.$slots["chart-background"] ? (o(), u("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: s.value.width <= 0 ? 10 : s.value.width,
          height: s.value.height <= 0 ? 10 : s.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          b(l.$slots, "chart-background", {}, void 0, !0)
        ], 8, Wt)) : i("", !0),
        e.value.type === "classic" ? (o(), u("defs", Ht, [
          e.value.style.chart.useGradient ? (o(), u("radialGradient", {
            key: 0,
            id: `gradient_${y.value}`
          }, [
            p("stop", {
              offset: "0%",
              "stop-color": n(Z)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Rt),
            p("stop", {
              offset: `${(1 - q.value / x.value) * 100}%`,
              "stop-color": n(Z)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, qt),
            p("stop", {
              offset: `${(1 - q.value / x.value / 2) * 100}%`,
              "stop-color": n(Z)("#FFFFFF", e.value.style.chart.gradientIntensity)
            }, null, 8, Jt),
            p("stop", {
              offset: "100%",
              "stop-color": n(Z)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Kt)
          ], 8, Et)) : i("", !0)
        ])) : i("", !0),
        e.value.type === "polar" ? (o(), u("defs", Qt, [
          (o(!0), u(g, null, F(c.value, (t, a) => (o(), u("radialGradient", {
            id: `polar_gradient_${a}_${y.value}`,
            cx: t.middlePoint.x / s.value.width * 100 + "%",
            cy: t.middlePoint.y / s.value.height * 100 + "%",
            r: "62%"
          }, [
            p("stop", {
              offset: "0%",
              "stop-color": n(kt)(h.value[a].color, 0.05),
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, el),
            p("stop", {
              offset: "100%",
              "stop-color": h.value[a].color
            }, null, 8, tl)
          ], 8, Zt))), 256))
        ])) : i("", !0),
        p("defs", null, [
          p("filter", {
            id: `blur_${y.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            p("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${y.value}`
            }, null, 8, al),
            r[8] || (r[8] = p("feColorMatrix", {
              type: "saturate",
              values: "0"
            }, null, -1))
          ], 8, ll),
          p("filter", {
            id: `shadow_${y.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            p("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, ul)
          ], 8, ol),
          p("filter", {
            id: `drop_shadow_${y.value}`,
            "color-interpolation-filters": "sRGB",
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            p("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "3",
              "flood-opacity": "1",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, nl)
          ], 8, sl)
        ]),
        e.value.type === "classic" ? (o(!0), u(g, { key: 3 }, F(h.value, (t, a) => (o(), u("g", null, [
          Y(t) && f.value.dataLabels.show ? (o(), u("path", {
            key: 0,
            d: n(_t)(t, { x: s.value.width / 2, y: s.value.height / 2 }, 16, 16, !1, !1, q.value),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: G(a)
          }, null, 8, rl)) : i("", !0)
        ]))), 256)) : i("", !0),
        e.value.type === "polar" ? (o(!0), u(g, { key: 4 }, F(h.value, (t, a) => (o(), u("g", null, [
          Y(t) && f.value.dataLabels.show ? (o(), u("line", {
            key: 0,
            x1: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
            y1: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y,
            x2: c.value[a].middlePoint.x,
            y2: c.value[a].middlePoint.y,
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: G(a)
          }, null, 8, il)) : i("", !0)
        ]))), 256)) : i("", !0),
        e.value.type === "classic" && e.value.style.chart.layout.donut.useShadow ? (o(), u("circle", {
          key: 5,
          cx: s.value.width / 2,
          cy: s.value.height / 2,
          r: x.value <= 0 ? 10 : x.value,
          fill: e.value.style.chart.backgroundColor,
          filter: `url(#shadow_${y.value})`
        }, null, 8, vl)) : i("", !0),
        l.$slots.pattern ? (o(), u("g", cl, [
          (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("defs", null, [
            b(l.$slots, "pattern", We({ ref_for: !0 }, { ...t, patternId: `pattern_${y.value}_${t.patternIndex}` }), void 0, !0)
          ]))), 256))
        ])) : i("", !0),
        S.value && e.value.type === "classic" ? (o(), u(g, { key: 7 }, [
          (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, dl))), 256)),
          l.$slots.pattern ? (o(), u("g", hl, [
            (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
              class: "vue-ui-donut-arc-path",
              d: t.arcSlice,
              fill: `url(#pattern_${y.value}_${t.patternIndex})`,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: G(a)
            }, null, 8, yl))), 256))
          ])) : i("", !0),
          (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: n(Z)(t.color, 80),
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: G(a)
          }, null, 8, fl))), 256))
        ], 64)) : i("", !0),
        S.value && e.value.type === "polar" ? (o(), u(g, { key: 8 }, [
          h.value.length > 1 ? (o(), u("g", pl, [
            (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
              stroke: e.value.style.chart.backgroundColor,
              d: c.value[a].path,
              fill: "#FFFFFF"
            }, null, 8, gl))), 256)),
            e.value.style.chart.layout.donut.useShadow ? (o(), u("g", bl, [
              (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
                class: "vue-ui-donut-arc-path",
                d: c.value[a].path,
                fill: "transparent",
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": e.value.style.chart.layout.donut.borderWidth,
                filter: `url(#drop_shadow_${y.value})`
              }, null, 8, ml))), 256))
            ])) : i("", !0),
            l.$slots.pattern ? (o(), u("g", wl, [
              (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
                class: "vue-ui-donut-arc-path",
                d: c.value[a].path,
                fill: `url(#pattern_${y.value}_${t.patternIndex})`,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": e.value.style.chart.layout.donut.borderWidth,
                filter: G(a)
              }, null, 8, kl))), 256))
            ])) : i("", !0),
            (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
              class: "vue-ui-donut-arc-path",
              d: c.value[a].path,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_${a}_${y.value})` : t.color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: G(a)
            }, null, 8, _l))), 256))
          ])) : (o(), u("g", xl, [
            l.$slots.pattern ? (o(), u("circle", {
              key: 0,
              cx: s.value.width / 2,
              cy: s.value.height / 2,
              r: x.value,
              fill: `url(#pattern_${y.value}_${h.value[0].patternIndex})`,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, $l)) : i("", !0),
            p("circle", {
              cx: s.value.width / 2,
              cy: s.value.height / 2,
              r: x.value,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_0_${y.value})` : h.value[0].color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, Cl)
          ]))
        ], 64)) : (o(), u("circle", {
          key: 9,
          cx: s.value.width / 2,
          cy: s.value.height / 2,
          r: x.value <= 0 ? 10 : x.value,
          fill: "transparent",
          stroke: e.value.style.chart.backgroundColor
        }, null, 8, Pl)),
        e.value.style.chart.useGradient && e.value.type === "classic" ? (o(), u("circle", {
          key: 10,
          cx: s.value.width / 2,
          cy: s.value.height / 2,
          r: (
            /* This might require adjustments */
            x.value <= 0 ? 10 : x.value
          ),
          fill: `url(#gradient_${y.value})`
        }, null, 8, Sl)) : i("", !0),
        S.value ? (o(), u(g, { key: 11 }, [
          h.value.length > 1 || e.value.type === "classic" ? (o(), u("g", Fl, [
            (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("path", {
              "data-cy-donut-trap": "",
              d: e.value.type === "classic" ? t.arcSlice : c.value[a].path,
              fill: P.value === a ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (v) => Ie({
                datapoint: t,
                relativeIndex: a,
                seriesIndex: t.seriesIndex,
                show: !0
              }),
              onMouseleave: r[0] || (r[0] = (v) => {
                le.value = !1, P.value = null;
              }),
              onClick: (v) => M(t, a)
            }, null, 40, Ll))), 256))
          ])) : (o(), u("g", Tl, [
            p("circle", {
              cx: s.value.width / 2,
              cy: s.value.height / 2,
              r: x.value,
              fill: P.value === l.i ? "rgba(0,0,0,0.1)" : "transparent",
              "data-cy-donut-trap": "",
              onMouseenter: r[1] || (r[1] = (t) => Ie({
                datapoint: h.value[0],
                relativeIndex: 0,
                seriesIndex: h.value[0].seriesIndex,
                show: !0
              })),
              onMouseleave: r[2] || (r[2] = (t) => {
                le.value = !1, P.value = null;
              }),
              onClick: r[3] || (r[3] = (t) => M(h.value[0], l.i))
            }, null, 40, zl)
          ]))
        ], 64)) : i("", !0),
        e.value.type === "classic" ? (o(), u(g, { key: 12 }, [
          e.value.style.chart.layout.labels.hollow.total.show ? (o(), u("text", {
            key: 0,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
            style: z(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
          }, C(e.value.style.chart.layout.labels.hollow.total.text), 13, Ol)) : i("", !0),
          e.value.style.chart.layout.labels.hollow.total.show ? (o(), u("text", {
            key: 1,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
            style: z(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
          }, C(n(A)(
            e.value.style.chart.layout.labels.hollow.total.value.formatter,
            S.value,
            n(O)({
              p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
              v: S.value,
              s: e.value.style.chart.layout.labels.hollow.total.value.suffix
            })
          )), 13, Yl)) : i("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (o(), u("text", {
            key: 2,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
            style: z(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
          }, C(e.value.style.chart.layout.labels.hollow.average.text), 13, Al)) : i("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (o(), u("text", {
            key: 3,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
            style: z(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
          }, C(V.value ? "--" : n(A)(
            e.value.style.chart.layout.labels.hollow.average.value.formatter,
            Ne.value,
            n(O)({
              p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
              v: Ne.value,
              s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
              r: e.value.style.chart.layout.labels.hollow.average.value.rounding
            })
          )), 13, Nl)) : i("", !0)
        ], 64)) : i("", !0),
        (o(!0), u(g, null, F(h.value, (t, a) => (o(), u("g", {
          filter: G(a),
          class: ce({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (o(), u("g", Il, [
            (o(), u("foreignObject", {
              x: n(w)(t, !0).anchor === "end" ? n(w)(t).x - 120 : n(w)(t, !0).anchor === "middle" ? n(w)(t).x - 60 : n(w)(t).x,
              y: n(ee)(t) - (Me.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              p("div", null, [
                b(l.$slots, "dataLabel", We({ ref_for: !0 }, {
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a,
                  isSafari: Me.value,
                  isVisible: Y(t) && f.value.dataLabels.show,
                  textAlign: n(w)(t, !0, 16, !0).anchor,
                  flexAlign: n(w)(t, !0, 16).anchor,
                  percentage: ne(t, h.value)
                }), void 0, !0)
              ])
            ], 8, Dl))
          ])) : (o(), u("g", Ml, [
            e.value.type === "classic" ? (o(), u(g, { key: 0 }, [
              Y(t) && f.value.dataLabels.show ? (o(), u("circle", {
                key: 0,
                cx: n(w)(t).x,
                cy: n(ee)(t) - 3.5,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a ? "" : `url(#blur_${y.value})`,
                onClick: (v) => M(t, a)
              }, null, 8, Bl)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.type === "polar" ? (o(), u(g, { key: 1 }, [
              Y(t) && f.value.dataLabels.show ? (o(), u("circle", {
                key: 0,
                cx: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
                cy: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a ? "" : `url(#blur_${y.value})`,
                onClick: (v) => M(t, a)
              }, null, 8, Vl)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.type === "classic" ? (o(), u(g, { key: 2 }, [
              Y(t) && f.value.dataLabels.show ? (o(), u("text", {
                key: 0,
                "text-anchor": n(w)(t, !0, 12).anchor,
                x: n(w)(t, !0, 12).x,
                y: n(ee)(t),
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: z(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (v) => M(t, a)
              }, C(ne(t, h.value)) + " " + C(e.value.style.chart.layout.labels.value.show ? `(${n(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                n(O)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, Gl)) : i("", !0),
              Y(t) && f.value.dataLabels.show ? (o(), u("text", {
                key: 1,
                "text-anchor": n(w)(t).anchor,
                x: n(w)(t, !0, 12).x,
                y: n(ee)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: z(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (v) => M(t, a)
              }, C(t.name), 13, Ul)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.type === "polar" ? (o(), u(g, { key: 3 }, [
              Y(t) && f.value.dataLabels.show ? (o(), u("text", {
                key: 0,
                "text-anchor": H(c.value[a].middlePoint),
                x: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
                y: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y,
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: z(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (v) => M(t, a)
              }, C(ne(t, h.value)) + " " + C(e.value.style.chart.layout.labels.value.show ? `(${n(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                n(O)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, jl)) : i("", !0),
              Y(t) && f.value.dataLabels.show ? (o(), u("text", {
                key: 1,
                "text-anchor": H(c.value[a].middlePoint),
                x: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
                y: n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: z(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (v) => M(t, a)
              }, C(t.name), 13, Wl)) : i("", !0)
            ], 64)) : i("", !0)
          ])),
          f.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (o(), u("g", Hl, [
            Y(t) && e.value.type === "classic" ? (o(), u("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (n(w)(t, !0).anchor === "end" ? n(w)(t).x - e.value.style.chart.comments.width : n(w)(t, !0).anchor === "middle" ? n(w)(t).x - e.value.style.chart.comments.width / 2 : n(w)(t).x),
              y: n(ee)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              p("div", null, [
                b(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: n(w)(t, !0, 16, !0).anchor, flexAlign: n(w)(t, !0, 16).anchor }
                }, void 0, !0)
              ])
            ], 8, El)) : i("", !0),
            Y(t) && e.value.type === "polar" ? (o(), u("foreignObject", {
              key: 1,
              x: e.value.style.chart.comments.offsetX + (H(c.value[a].middlePoint) === "end" ? n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x - e.value.style.chart.comments.width : H(c.value[a].middlePoint) === "middle" ? n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x - e.value.style.chart.comments.width / 2 : n(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x),
              y: ut(c.value[a]) + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              p("div", null, [
                b(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: H(c.value[a].middlePoint), flexAlign: H(c.value[a].middlePoint) }
                }, void 0, !0)
              ])
            ], 8, Rl)) : i("", !0)
          ])) : i("", !0)
        ], 10, Xl))), 256)),
        b(l.$slots, "svg", { svg: s.value }, void 0, !0)
      ], 14, jt)) : i("", !0),
      l.$slots.watermark ? (o(), u("div", ql, [
        b(l.$slots, "watermark", K(Q({ isPrinting: n(Ce) || n(Pe) })), void 0, !0)
      ])) : i("", !0),
      R.value ? i("", !0) : (o(), U(Xt, {
        key: 6,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: q.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      p("div", {
        ref_key: "chartLegend",
        ref: ye
      }, [
        e.value.style.chart.legend.show ? (o(), U(Nt, {
          key: `legend_${me.value}`,
          legendSet: Ae.value,
          config: ot.value,
          onClickMarker: r[4] || (r[4] = ({ i: t }) => Ye(t))
        }, je({
          item: $(({ legend: t, index: a }) => [
            p("div", {
              style: z(`opacity:${X.value.includes(a) ? 0.5 : 1}`),
              onClick: (v) => t.segregate()
            }, [
              He(C(t.name) + ": " + C(n(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                n(O)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: a
                }
              )) + " ", 1),
              X.value.includes(a) ? (o(), u("span", Ql, " ( " + C(rt(t.proportion * 100)) + " % ) ", 1)) : (o(), u("span", Kl, " (" + C(isNaN(t.value / S.value) ? "-" : n(A)(
                e.value.style.chart.layout.labels.percentage.formatter,
                Xe.value(t),
                n(O)({
                  v: Xe.value(t),
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, Jl)
          ]),
          _: 2
        }, [
          l.$slots.pattern ? {
            name: "legend-pattern",
            fn: $(({ legend: t, index: a }) => [
              de(Vt, {
                shape: t.shape,
                radius: 30,
                stroke: "none",
                plot: { x: 30, y: 30 },
                fill: `url(#pattern_${y.value}_${a})`
              }, null, 8, ["shape", "fill"])
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["legendSet", "config"])) : i("", !0),
        b(l.$slots, "legend", { legend: Ae.value }, void 0, !0)
      ], 512),
      l.$slots.source ? (o(), u("div", {
        key: 7,
        ref_key: "source",
        ref: fe,
        dir: "auto"
      }, [
        b(l.$slots, "source", {}, void 0, !0)
      ], 512)) : i("", !0),
      de(At, {
        show: f.value.showTooltip && le.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: W.value,
        content: ue.value,
        isCustom: J.value,
        isFullscreen: E.value
      }, {
        "tooltip-before": $(() => [
          b(l.$slots, "tooltip-before", K(Q({ ...re.value })), void 0, !0)
        ]),
        "tooltip-after": $(() => [
          b(l.$slots, "tooltip-after", K(Q({ ...re.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "isFullscreen"]),
      R.value ? (o(), U(It, {
        key: 8,
        hideDetails: "",
        config: {
          open: f.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: $(() => [
          (o(), U(Yt, {
            key: `table_${be.value}`,
            colNames: ae.value.colNames,
            head: ae.value.head,
            body: ae.value.body,
            config: ae.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: r[5] || (r[5] = (t) => f.value.showTable = !1)
          }, {
            th: $(({ th: t }) => [
              p("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Zl)
            ]),
            td: $(({ td: t }) => [
              He(C(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? t : n(A)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                n(O)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : n(A)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                n(O)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : i("", !0)
    ], 46, Ut));
  }
}, ga = /* @__PURE__ */ Gt(ea, [["__scopeId", "data-v-854de761"]]);
export {
  ga as default
};
