import { ref as n, onMounted as Y, computed as A, onBeforeUnmount as Z, watch as ee, createElementBlock as r, openBlock as l, normalizeStyle as f, createCommentVNode as h, createElementVNode as _, createBlock as te, unref as ae, createVNode as M, renderSlot as z, mergeProps as X, normalizeProps as U, guardReactiveProps as W, toDisplayString as se } from "vue";
import { u as le } from "./useNestedProp--JNGbFip.js";
import { u as oe, c as re, X as ue, F as G } from "./index-CokOzopo.js";
import { t as ie, u as ne } from "./useResponsive-CoxXLe23.js";
import I from "./BaseIcon-C5u0vAc0.js";
import { _ as ce } from "./Title-_eGGQuGI.js";
import { _ as de } from "./PackageVersion-BPWkS_lI.js";
import { _ as he } from "./_plugin-vue_export-helper-CHgC5LLL.js";
class ve {
  constructor(H, L, P, S = !0, w = !0) {
    this.interval = L, this.elapsed = 0, this.isPaused = !1;
    const C = `
            let interval;
            let elapsed = 0;
            let paused = false;
            let startTime;
            let tickInterval;

            onmessage = function(e) {
                const { action, data } = e.data;

                switch(action) {
                    case 'start':
                        startTime = Date.now();
                        tickInterval = data.interval;
                        elapsed = 0;
                        paused = false;
                        interval = setInterval(() => {
                            elapsed += tickInterval;
                            postMessage({ elapsed, timestamp: Date.now() });
                        }, tickInterval);
                        break;
                    
                    case 'pause':
                        paused = true;
                        clearInterval(interval);
                        elapsed = Date.now() - startTime;
                        break;

                    case 'resume':
                        if (paused) {
                            startTime = Date.now() - elapsed;
                            interval = setInterval(() => {
                                elapsed += tickInterval;
                                postMessage({ elapsed, timestamp: Date.now() });
                            }, tickInterval);
                        }
                        paused = false;
                        break;

                    case 'stop':
                        clearInterval(interval);
                        elapsed = 0;
                        postMessage({ elapsed });
                        break;

                    case 'reset':
                        elapsed = 0;
                        clearInterval(interval);
                        postMessage({ elapsed });
                        break;

                    case 'lap':
                        postMessage({
                            elapsed,
                            timestamp: Date.now(),
                            action: 'lap'
                        });
                        break;

                    default:
                        break;
                }
            };
        `, R = new Blob([C], { type: "application/javascript" }), D = URL.createObjectURL(R), u = new Worker(D);
    function T(c) {
      let v = Math.floor(c / 1e3), e = Math.floor(c % 1e3 / 10), k = Math.floor(v / 3600), $ = Math.floor(v % 3600 / 60), t = v % 60, o = "";
      return w && (o += String(k).padStart(2, "0") + ":"), o += String($).padStart(2, "0") + ":", o += String(t).padStart(2, "0"), S && (o += "." + String(e).padStart(2, "0")), o;
    }
    this.start = () => {
      this.isPaused = !1, u.postMessage({ action: "start", data: { interval: this.interval } });
    }, this.pause = () => {
      this.isPaused ? this.resume() : (this.isPaused = !0, u.postMessage({ action: "pause" }));
    }, this.resume = () => {
      this.isPaused && (u.postMessage({ action: "resume" }), this.isPaused = !1);
    }, this.stop = () => {
      u.postMessage({ action: "stop" }), this.isPaused = !1;
    }, this.reset = () => {
      u.postMessage({ action: "reset" }), this.elapsed = 0, this.isPaused = !1;
    }, this.restart = () => {
      this.stop(), this.start();
    }, this.lap = () => new Promise((c) => {
      u.postMessage({ action: "lap" });
      const v = (e) => {
        const { elapsed: k, timestamp: $, action: t } = e.data;
        if (t === "lap") {
          const o = T(k);
          c({
            timestamp: $ || 0,
            elapsed: k,
            formatted: o
          });
        }
      };
      u.addEventListener("message", v, { once: !0 });
    }), u.onmessage = (c) => {
      const { elapsed: v, timestamp: e } = c.data;
      this.elapsed = v, H({
        timestamp: e || 0,
        elapsed: this.elapsed,
        formatted: T(this.elapsed)
      });
    }, u.onerror = (c) => {
      P && P(c);
    };
  }
}
const pe = ["xmlns", "viewBox"], fe = ["width", "height"], we = { key: 1 }, ke = ["id"], ge = ["stop-color"], me = ["stop-color"], ye = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], be = ["d", "stroke", "stroke-width"], _e = ["r", "fill", "stroke", "stroke-width"], Me = ["r", "fill", "stroke", "stroke-width"], Ce = ["x", "y"], Te = ["x", "y", "font-size", "fill", "font-weight"], $e = {
  key: 0,
  class: "vue-ui-timer-controls"
}, xe = ["title"], Ie = ["title"], Pe = ["title"], Se = ["title"], Re = ["title"], De = {
  __name: "vue-ui-timer",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["start", "pause", "reset", "restart", "lap"],
  setup(V, { expose: H, emit: L }) {
    const { vue_ui_timer: P } = oe(), S = V, w = L, C = n(null), R = n(null), D = n(null), u = n(null), T = n(re()), c = n(0);
    Y(() => {
      v();
    });
    function v() {
      if (e.value.responsive) {
        const a = ie(() => {
          const { width: i, height: d } = ne({
            chart: C.value,
            title: e.value.style.title.text ? R.value : null,
            legend: D.value
          });
          requestAnimationFrame(() => {
            t.value.width = i, t.value.height = d, t.value.tracker.core = G({
              relator: Math.min(i, d),
              adjuster: e.value.style.width,
              source: 6 * e.value.stopwatch.tracker.radiusRatio,
              threshold: 1,
              fallback: 1
            }), t.value.tracker.aura = G({
              relator: Math.min(i, d),
              adjuster: e.value.style.width,
              source: 12 * e.value.stopwatch.tracker.aura.radiusRatio,
              threshold: 1,
              fallback: 1
            }), t.value.label = G({
              relator: Math.min(i, d),
              adjuster: e.value.style.width,
              source: e.value.stopwatch.label.fontSize,
              threshold: 10,
              fallback: 10
            });
          });
        });
        u.value = new ResizeObserver(a), u.value.observe(C.value.parentNode);
      }
    }
    Z(() => {
      u.value && u.value.disconnect();
    });
    const e = A({
      get: () => k(),
      set: (a) => a
    });
    function k() {
      return le({
        userConfig: S.config,
        defaultConfig: P
      });
    }
    ee(() => S.config, (a) => {
      e.value = k(), v(), c.value += 1;
    }, { deep: !0 });
    const $ = A(() => {
      if (e.value.stopwatch.showHours && e.value.stopwatch.showHundredth)
        return "00:00:00.00";
      if (e.value.stopwatch.showHours && !e.value.stopwatch.showHundredth)
        return "00:00:00";
      if (!e.value.stopwatch.showHours && e.value.stopwatch.showHundredth)
        return "00:00.00";
      if (!e.value.stopwatch.showHours && !e.value.stopwatch.showHundredth)
        return "00:00";
    }), t = n({
      height: e.value.style.height,
      width: e.value.style.width,
      tracker: {
        core: 6 * e.value.stopwatch.tracker.radiusRatio,
        aura: 12 * e.value.stopwatch.tracker.aura.radiusRatio
      },
      label: e.value.stopwatch.label.fontSize
    }), o = n(0), m = new ve(
      (a) => q(a),
      10,
      "",
      e.value.stopwatch.showHundredth,
      e.value.stopwatch.showHours
    ), N = n(!0), s = n(!1), p = n(!1);
    function j() {
      w("start"), N.value && m.start(), N.value = !1, s.value = !0;
    }
    function B() {
      s.value && (w("reset"), m.stop(), y.value = [], N.value = !0, s.value = !1);
    }
    function O() {
      p.value = !p.value, w("pause", o.value), m.pause();
    }
    function E() {
      s.value && (p.value = !1, w("restart"), y.value = [], m.restart());
    }
    const y = n([]);
    async function F() {
      if (!s.value || p.value) return;
      const a = await m.lap();
      a && (y.value.push(a), w("lap", y.value));
    }
    function q({ timestamp: a, elapsed: i, formatted: d }) {
      o.value = { timestamp: a, elapsed: i, formatted: d };
    }
    const g = A(() => Math.min(t.value.width, t.value.height) / 2.5 * e.value.stopwatch.track.radiusRatio);
    function J(a, i) {
      const x = 360 / (i * 1e3);
      return a * x % 360;
    }
    function K(a) {
      let i = a * (Math.PI / 180), d = t.value.width / 2 + g.value * Math.cos(i), x = t.value.height / 2 + g.value * Math.sin(i);
      return { cx: d, cy: x };
    }
    const b = A(() => {
      const a = J(o.value.elapsed, e.value.stopwatch.cycleSeconds), { cx: i, cy: d } = K(a - 90), x = a > 180 ? 1 : 0;
      return {
        cx: i || t.value.width / 2,
        cy: d || t.value.height / 2 - g.value,
        largeArcFlag: x,
        sweepFlag: 1
      };
    });
    return H({
      start: j,
      pause: O,
      reset: B,
      restart: E,
      lap: F
    }), (a, i) => (l(), r("div", {
      ref_key: "timerChart",
      ref: C,
      class: "vue-ui-timer",
      style: f({
        fontFamily: e.value.style.fontFamily,
        width: "100%",
        height: e.value.responsive ? "100%" : "auto",
        textAlign: "center"
      })
    }, [
      e.value.style.title.text ? (l(), r("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: R,
        style: f({
          width: "100%",
          background: e.value.style.backgroundColor
        })
      }, [
        (l(), te(ce, {
          key: `title_${c.value}`,
          config: {
            title: {
              cy: "title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : h("", !0),
      (l(), r("svg", {
        xmlns: ae(ue),
        viewBox: `0 0 ${t.value.width <= 0 ? 10 : t.value.width} ${t.value.height <= 0 ? 10 : t.value.height}`,
        style: f({
          maxWidth: "100%",
          overflow: "visible",
          background: e.value.style.backgroundColor
        })
      }, [
        M(de),
        a.$slots["chart-background"] ? (l(), r("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: t.value.width <= 0 ? 10 : t.value.width,
          height: t.value.height <= 0 ? 10 : t.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          z(a.$slots, "chart-background", {}, void 0, !0)
        ], 8, fe)) : h("", !0),
        e.value.stopwatch.tracker.gradient.show ? (l(), r("defs", we, [
          _("radialGradient", {
            id: `tracker_gradient_${T.value}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            _("stop", {
              offset: "0%",
              "stop-color": e.value.stopwatch.tracker.gradient.color
            }, null, 8, ge),
            _("stop", {
              offset: "100%",
              "stop-color": e.value.stopwatch.tracker.fill
            }, null, 8, me)
          ], 8, ke)
        ])) : h("", !0),
        _("circle", {
          cx: t.value.width / 2,
          cy: t.value.height / 2,
          r: g.value,
          fill: e.value.stopwatch.track.fill,
          stroke: e.value.stopwatch.track.stroke,
          "stroke-width": e.value.stopwatch.track.strokeWidth
        }, null, 8, ye),
        e.value.stopwatch.cycleTrack.show ? (l(), r("path", {
          key: 2,
          d: `M ${t.value.width / 2},${t.value.height / 2 - g.value} A ${g.value},${g.value} 0 ${b.value.largeArcFlag},${b.value.sweepFlag} ${b.value.cx},${b.value.cy}`,
          stroke: e.value.stopwatch.cycleTrack.stroke,
          "stroke-width": e.value.stopwatch.cycleTrack.strokeWidth,
          "stroke-linecap": "round",
          fill: "none"
        }, null, 8, be)) : h("", !0),
        _("circle", X(b.value, {
          r: t.value.tracker.core,
          fill: e.value.stopwatch.tracker.gradient.show ? `url(#tracker_gradient_${T.value})` : e.value.stopwatch.tracker.fill,
          stroke: e.value.stopwatch.tracker.stroke,
          "stroke-width": e.value.stopwatch.tracker.strokeWidth
        }), null, 16, _e),
        e.value.stopwatch.tracker.aura.show ? (l(), r("circle", X({ key: 3 }, b.value, {
          r: t.value.tracker.aura,
          fill: `${e.value.stopwatch.tracker.aura.fill}20`,
          stroke: e.value.stopwatch.tracker.aura.stroke,
          "stroke-width": e.value.stopwatch.tracker.aura.strokeWidth
        }), null, 16, Me)) : h("", !0),
        a.$slots.time ? (l(), r("foreignObject", {
          key: 4,
          x: t.value.width / 2,
          y: t.value.height / 2,
          height: "0.1",
          width: "0.1",
          style: { overflow: "visible" }
        }, [
          z(a.$slots, "time", U(W({ ...o.value })), void 0, !0)
        ], 8, Ce)) : (l(), r("text", {
          key: 5,
          x: t.value.width / 2,
          y: t.value.height / 2 + t.value.label / 4,
          "font-size": t.value.label,
          "text-anchor": "middle",
          fill: e.value.stopwatch.label.color,
          "font-weight": e.value.stopwatch.label.bold ? "bold" : "normal",
          style: { "font-variant-numeric": "tabular-nums !important" }
        }, se(o.value.formatted || $.value), 9, Te))
      ], 12, pe)),
      _("div", {
        ref_key: "chartLegend",
        ref: D,
        style: f({ width: "100%", backgroundColor: e.value.stopwatch.legend.backgroundColor })
      }, [
        a.$slots.controls ? h("", !0) : (l(), r("div", $e, [
          e.value.stopwatch.legend.buttons.start ? (l(), r("button", {
            key: 0,
            title: e.value.stopwatch.legend.buttonTitles.start,
            onClick: j,
            class: "vue-ui-timer-button",
            style: f({
              opacity: s.value ? 0.2 : 1,
              cursor: s.value ? "default" : "pointer"
            })
          }, [
            M(I, {
              name: "play",
              stroke: e.value.stopwatch.legend.buttons.iconColor
            }, null, 8, ["stroke"])
          ], 12, xe)) : h("", !0),
          e.value.stopwatch.legend.buttons.pause ? (l(), r("button", {
            key: 1,
            title: p.value ? e.value.stopwatch.legend.buttonTitles.resume : e.value.stopwatch.legend.buttonTitles.pause,
            onClick: O,
            class: "vue-ui-timer-button",
            style: f({
              opacity: s.value ? 1 : 0.2,
              cursor: s.value ? "pointer" : "default"
            })
          }, [
            M(I, {
              name: "pause",
              stroke: e.value.stopwatch.legend.buttons.iconColor
            }, null, 8, ["stroke"])
          ], 12, Ie)) : h("", !0),
          e.value.stopwatch.legend.buttons.reset ? (l(), r("button", {
            key: 2,
            title: e.value.stopwatch.legend.buttonTitles.reset,
            onClick: B,
            class: "vue-ui-timer-button",
            style: f({
              opacity: s.value ? 1 : 0.2,
              cursor: s.value ? "pointer" : "default"
            })
          }, [
            M(I, {
              name: "stop",
              stroke: e.value.stopwatch.legend.buttons.iconColor
            }, null, 8, ["stroke"])
          ], 12, Pe)) : h("", !0),
          e.value.stopwatch.legend.buttons.restart ? (l(), r("button", {
            key: 3,
            title: e.value.stopwatch.legend.buttonTitles.restart,
            onClick: E,
            class: "vue-ui-timer-button",
            style: f({
              opacity: s.value ? 1 : 0.2,
              cursor: s.value ? "pointer" : "default"
            })
          }, [
            M(I, {
              name: "restart",
              stroke: e.value.stopwatch.legend.buttons.iconColor
            }, null, 8, ["stroke"])
          ], 12, Se)) : h("", !0),
          e.value.stopwatch.legend.buttons.lap ? (l(), r("button", {
            key: 4,
            title: e.value.stopwatch.legend.buttonTitles.lap,
            onClick: F,
            class: "vue-ui-timer-button",
            style: f({
              opacity: s.value && !p.value ? 1 : 0.2,
              cursor: s.value && !p.value ? "pointer" : "default"
            })
          }, [
            M(I, {
              name: "lap",
              stroke: e.value.stopwatch.legend.buttons.iconColor
            }, null, 8, ["stroke"])
          ], 12, Re)) : h("", !0)
        ])),
        z(a.$slots, "controls", U(W({
          start: j,
          pause: O,
          reset: B,
          restart: E,
          lap: F,
          laps: y.value,
          isRunning: s.value,
          isPaused: p.value,
          ...o.value
        })), void 0, !0),
        z(a.$slots, "laps", U(W({
          laps: y.value,
          lap: F,
          isRunning: s.value,
          isPaused: p.value,
          ...o.value
        })), void 0, !0)
      ], 4)
    ], 4));
  }
}, Oe = /* @__PURE__ */ he(De, [["__scopeId", "data-v-be90052b"]]);
export {
  Oe as default
};
